<template>
    <div class="edit-content">
        <a class="close-edit-content" @click="close"><i class="fas fa-angle-double-right"></i></a>
        <a class="logout-user" @click="logout"><i class="fas fa-sign-out-alt"></i></a>
        <h2 class="title">
            Editar contenido
        </h2>
        <div class="form-edit-content">
            <img class="image-temporary" :src="imageURL" height="200" @click="activeFile">
            <input type="file" class="display-none" name="name" id="bg_image" autocomplete="off" ref="fileImage"
                   required accept="image/*" @change="onFilePicked">

            <div class="input-field">
                <input type="text" name="name" id="name" autocomplete="off"
                       v-model="title" required>
                <label for="name">Título</label>
                <span></span>
            </div>
            <div class="list-items">
                <h2 class="title">Cursos</h2>
                <ul>
                    <template v-for="(course, index) in courses">
                        <li :key="index">
                            <span @click="selectedCourse(course)">{{course.title}}</span>
                            <a class="remove" @click="removeCourse(course)"><i class="fas fa-times"></i></a>
                        </li>
                    </template>
                </ul>
                <a @click="showFormAddCourse">{{show_form_add_course ? 'Cerrar' : 'Añadir'
                    }}</a>

                <div class="input-field" v-show="show_form_add_course">
                    <input type="text" name="name" id="add_course" autocomplete="off" required
                           v-model="new_course"
                           v-on:keyup.13="addCourse">
                    <label for="add_course">Agregar curso</label>
                    <span>{{message_helper_form}}</span>
                </div>
            </div>
            <div class="list-items">
                <h2 class="title">Redes sociales</h2>
                <ul>
                    <template v-for="(social, index) in social_network">
                        <li :key="index">
                            <span @click="selectedSocial(social)">{{social.title}}</span>
                            <a class="remove" @click="removeSocial(social)"><i class="fas fa-times"></i></a>
                        </li>
                    </template>
                </ul>
                <a @click="showFormAddSocial">{{show_form_add_social ? 'Cerrar' : 'Añadir' }}</a>
                <div v-show="show_form_add_social">
                    <div class="input-field">
                        <input type="text" name="name" id="title_social" autocomplete="off" required
                               v-model="new_social.title"
                               v-on:keyup.13="addSocial">
                        <label for="title_social">Título Red social</label>
                        <span></span>
                    </div>
                    <div class="input-field">
                        <input type="text" name="name" id="url_social" autocomplete="off" required
                               v-model="new_social.url"
                               v-on:keyup.13="addSocial">
                        <label for="url_social">URL Red social</label>
                        <span></span>
                    </div>
                    <div class="input-field">
                        <input type="text" name="name" id="icon_social" autocomplete="off" required
                               v-model="new_social.icon"
                               v-on:keyup.13="addSocial">
                        <label for="icon_social">Ícono Red social</label>
                        <span><a href="https://fontawesome.com/v5.9.0/icons"
                                 target="_blank">Íconos</a> {{message_helper_form}}</span>
                    </div>
                </div>
            </div>

            <div class="input-field">
                <input type="text" name="copyright" id="copyright" autocomplete="off"
                       v-model="copyright" required>
                <label for="copyright">Copyright</label>
                <span></span>
            </div>

            <button @click="savePage">Guardar</button>
        </div>
    </div>
</template>

<script>
    import {mapState, mapActions} from 'vuex'
    import {auth} from "../plugins/firebase"
    import {eventBus} from './../utils/EventBus'

    export default {
        name: "EditContent",
        data: () => ({
            image: '',
            new_course: '',
            new_social: {
                title: '',
                url: '',
                icon: '',
            },
            selected_course: false,
            selected_social: false,
            instance_temporary: null,
            show_form_add_course: false,
            show_form_add_social: false,
            message_helper_form: "Al terminar, presiona enter para agregar uno nuevo o guardar.",
        }),
        computed: {
            ...mapState([
                'page'
            ]),
            title: {
                set(title) {
                    this.$store.commit('SET_DATA_STATE', {title})
                },
                get() {
                    return this.page.title
                }
            },
            copyright: {
                set(copyright) {
                    this.$store.commit('SET_DATA_STATE', {copyright})
                },
                get() {
                    return this.page.copyright
                }
            },
            imageURL: {
                get() {
                    return this.page.imageURL
                }
            },
            courses: {
                set(course) {
                    this.$store.commit('SET_DATA_STATE', {course})
                },
                get() {
                    return this.page.courses
                }
            },
            social_network: {
                set(social) {
                    this.$store.commit('SET_DATA_STATE', {social})
                },
                get() {
                    return this.page.social_network
                }
            }
        },
        methods: {
            ...mapActions(['addPage']),

            logout() {
                auth.signOut().then(() => {
                    eventBus.$emit('activeUser');
                })
            },
            close() {
                this.$emit('close');
            },
            showFormAddCourse() {
                this.show_form_add_course = !this.show_form_add_course;
                if(!this.show_form_add_course) {
                    this.new_course = '';
                }
            },
            showFormAddSocial() {
                this.show_form_add_social = !this.show_form_add_social;
                if(!this.show_form_add_social) {
                    this.new_social.title = '';
                    this.new_social.url = '';
                    this.new_social.icon = '';
                }
            },
            activeFile() {
                this.$refs.fileImage.click();
            },
            onFilePicked(event) {
                const files = event.target.files;
                let fileName = files[0].name;
                if (fileName.lastIndexOf('.') <= 0) {
                    return alert('Por favor agregar un archivo válido')
                }
                const fileReader = new FileReader();
                fileReader.addEventListener('load', () => {
                    this.page.imageURL = fileReader.result;
                });
                fileReader.readAsDataURL(files[0]);
                this.image = files[0];
            },
            savePage() {
                this.$store.dispatch('addPage', {image: this.image}).then(() => {
                    this.$emit('saved');
                })
            },
            removeCourse(course) {
                const index = this.courses.indexOf(course);
                this.courses.splice(index, 1)
            },
            selectedCourse(course) {
                this.selected_course = true;
                this.show_form_add_course = true;
                this.instance_temporary = course;
                this.new_course = this.instance_temporary.title;
            },
            addCourse() {
                if (this.selected_course) {
                    this.courses.forEach(item => {
                        if (item === this.instance_temporary) {
                            item.title = this.new_course;
                        }
                    });
                    this.selected_course = false;
                } else {
                    this.courses.push({'title': this.new_course});
                }
                this.new_course = '';
            },
            removeSocial(social) {
                const index = this.social_network.indexOf(social);
                this.social_network.splice(index, 1)
            },
            selectedSocial(social) {
                this.show_form_add_social = true;
                this.selected_social = true;
                this.instance_temporary = social;
                this.new_social.title = this.instance_temporary.title;
                this.new_social.url = this.instance_temporary.url;
                this.new_social.icon = this.instance_temporary.icon;
            },
            addSocial() {
                if (this.selected_social) {
                    this.social_network.forEach(item => {
                        if (item === this.instance_temporary) {
                            item.title = this.new_social.title;
                            item.url = this.new_social.url;
                            item.icon = this.new_social.icon;
                        }
                    });
                    this.selected_social = false;
                } else {
                    this.social_network.push({
                        'title': this.new_social.title,
                        'url': this.new_social.url,
                        'icon': this.new_social.icon,
                    });
                }

                this.new_social.title = '';
                this.new_social.url = '';
                this.new_social.icon = '';
            }
        }
    }
</script>

<style scoped lang="scss">

    @import "./../assets/css/form";

    .display-none {
        display: none;
    }

    .close-edit-content, .logout-user {
        position: absolute;
        left: 15px;
        top: 20px;
        font-weight: bold;
        font-size: 1.5rem;
        cursor: pointer;
        transition: font-size .1s;

        &:hover {
            font-size: 1.55rem;
            text-shadow: 1px 1px 2px black;
        }
    }

    .logout-user {
        right: 15px;
        left: auto;
        top: 10px;
        font-size: 1rem;
        &:hover {
            font-size: 1.05rem;
        }
    }

    .image-temporary {
        margin-bottom: 20px;
        cursor: pointer;
        box-shadow: 0 3px 9px -4px rgba(0,0,0,.25);
        border-radius: 2px;
    }

    .edit-content {
        width: 30%;
        position: fixed;
        right: 0;
        top: 0;
        height: 100vh;
        background-color: #ffffff;
        z-index: 3;
        color: #000000;
        padding: 20px;
        overflow-y: scroll;
    }

    .title {
        font-size: 1.7rem;
        font-weight: bold;
        margin: 0 auto 50px;
    }

    .list-items {
        margin: 10px;

        .title {
            font-weight: bold;
            margin: 10px;
            text-align: center;
            opacity: .8;
            font-size: 1.5rem;
        }

        a {
            text-decoration: none;
            color: $primary;
            cursor: pointer;
            outline: none;

            &:hover, &:visited, &:focus {
                color: $second;
                outline: none;
            }
        }

        ul {
            text-align: left;
            padding: 0 20px;

            li {
                margin: 10px;
                width: 100%;

                span {
                    cursor: pointer;
                }

                a {
                    cursor: pointer;
                    text-decoration: none;
                    font-weight: bold;
                    float: right;
                }
            }
        }
    }

    ::-webkit-scrollbar {
        width: 5px;
    }

    ::-webkit-scrollbar-track {
        -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.14);
        border-radius: 2px;
    }

    ::-webkit-scrollbar-thumb {
        border-radius: 2px;
        background-color: $primary;
        -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.77);
    }

</style>
